﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using WinForm_Test;

namespace UHFAPP
{
    public partial class ConfigForm : Form
    {
        public ConfigForm(bool isOpen)
        {
            InitializeComponent();
            if (isOpen)
            {
                panel1.Enabled = true;
            }
            else
            {
                panel1.Enabled = false;
            }
            cmbAntWorkTime.SelectedIndex = 0;
        }

        void MainForm_eventOpen(bool open)
        {
            if (open)
            {
                panel1.Enabled = true;
            }
            else
            {
                panel1.Enabled = false;
            }
        }

        private void ConfigForm_Load(object sender, EventArgs e)
        {
            MainForm.eventOpen += MainForm_eventOpen;
            cmbLinkFrequency.SelectedIndex = 3;
 
            MainForm.eventSwitchUI += MainForm_eventSwitchUI;
            MainForm_eventSwitchUI();
        }

        private void ConfigForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            MainForm.eventOpen -= MainForm_eventOpen;
            MainForm.eventSwitchUI -= MainForm_eventSwitchUI;
        }
        #region 功率
        private void btnPowerGet_Click(object sender, EventArgs e)
        {
            string msg = Common.isEnglish?"Get the power failure!":"获取功率失败!";
            byte power = 0;
            if (UHFAPI.getInstance().GetPower(ref power))
            {
                cmbPower.SelectedIndex = power - 5;
                msg = Common.isEnglish?"Get the power success":"获取功率成功!";
            }
           

            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }

        private void btnPowerSet_Click(object sender, EventArgs e)
        {
            string msg =Common.isEnglish? "Set the power failure!":"设置功率失败!";
            if (cmbPower.SelectedIndex >= 0)
            {
                byte power = (byte)(cmbPower.SelectedIndex + 5);
                byte save = (byte)(cbSave.Checked?1:0);
                if (UHFAPI.getInstance().SetPower(save, power))
                {
                    msg=Common.isEnglish?"Set the power success!":"设置功率成功!";
                }
                
            }
            
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }
        #endregion

        #region 工作频率
        private void btnWorkModeSet_Click(object sender, EventArgs e)
        {
             string msg =Common.isEnglish? "failure!":"频点失败!";
             try
             {
                 string frequency = textBox1.Text.Replace(".","");

                 if (StringUtils.IsNumber(frequency))
                 {
                     int[] ifrequency = new int[] { int.Parse(frequency) };
                     if (UHFAPI.getInstance().SetJumpFrequency(1, ifrequency))
                     {
                         msg = Common.isEnglish?"success!":"设置频点成功!";
                     }
                 }
             }
             catch (Exception ex) { 
             
             }

             frmWaitingBox f = new frmWaitingBox((obj, args) =>
             {
                 System.Threading.Thread.Sleep(500);
             }, msg);
             f.ShowDialog(this);
        }
        private void btnWorkModeGet_Click(object sender, EventArgs e)
        {
            string msg =Common.isEnglish? "failure!":"获取频点失败!";
            int[] ifrequency = new int[1];
            if (UHFAPI.getInstance().GetJumpFrequency(ref ifrequency))
            {
                textBox1.Text = ifrequency[0].ToString().Insert(3, ".");
                msg = Common.isEnglish?"success!":"获取频点成功!";
            }
            
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }
        #endregion

        #region Gen2
        private void btnGen2Get_Click(object sender, EventArgs e)
        {
            byte Target = 0;
            byte Action = 0;
            byte T = 0;
            byte Q = 0;
            byte StartQ = 0;
            byte MinQ = 0;
            byte MaxQ = 0;
            byte D = 0;
            byte Coding = 0;
            byte P = 0;
            byte Sel = 0;
            byte Session = 0;
            byte G = 0;
            byte LF = 0;
            string msg = Common.isEnglish?"failure":"获取失败!";
            if (UHFAPI.getInstance().GetGen2(ref  Target, ref   Action, ref   T, ref   Q,
                     ref   StartQ, ref   MinQ,
                     ref   MaxQ, ref   D, ref   Coding, ref   P,
                     ref   Sel, ref   Session, ref   G, ref   LF))
            {
                cmbTarget.SelectedIndex = Target;
                cmbAction.SelectedIndex = Action;
                cmbT.SelectedIndex = T;
                cmbQ.SelectedIndex = Q;
                cmbCoding.SelectedIndex = Coding;
                cmbP.SelectedIndex = P;
                cmbSel.SelectedIndex = Sel;
                cmbStartQ.SelectedIndex = StartQ;
                cmbMinQ.SelectedIndex = MinQ;
                cmbMaxQ.SelectedIndex = MaxQ;
                cmbDr.SelectedIndex = D;
                cmbSession.SelectedIndex = Session;
                cmbG.SelectedIndex = G;
                cmbLinkFrequency.SelectedIndex = LF;
                msg = Common.isEnglish?"success":"获取成功!";
                btnGen2Set.Enabled = true;
            }
            

            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }
        private void btnGen2Set_Click(object sender, EventArgs e)
        {
            string msg =Common.isEnglish? "Set the Gen2 failure!":"设置失败!";
            try
            {
                byte Target =(byte) cmbTarget.SelectedIndex;
                byte Action = (byte)cmbAction.SelectedIndex;
                byte T = (byte)cmbT.SelectedIndex;
                byte Q = (byte)cmbQ.SelectedIndex;
                byte StartQ = (byte)cmbStartQ.SelectedIndex;
                byte MinQ = (byte)cmbMinQ.SelectedIndex;
                byte MaxQ = (byte)cmbMaxQ.SelectedIndex;
                byte D = (byte)cmbDr.SelectedIndex;
                byte Coding = (byte)cmbCoding.SelectedIndex;
                byte P = (byte)cmbP.SelectedIndex;
                byte Sel = (byte)cmbSel.SelectedIndex;
                byte Session = (byte)cmbSession.SelectedIndex;
                byte G = (byte)cmbG.SelectedIndex;
                byte LF = (byte)cmbLinkFrequency.SelectedIndex;
                if (UHFAPI.getInstance().SetGen2(Target, Action, T, Q, StartQ, MinQ, MaxQ, D, Coding, P, Sel, Session, G, LF))
                {
                    msg = Common.isEnglish?"Set the Gen2 success!":"设置成功!"; 
                }
                
            }
            catch (Exception ex)
            {
               
            }
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }
        #endregion

        #region CW
        private void btnGetCW_Click(object sender, EventArgs e)
        {
            string msg = "failure!";
            if (UHFAPI.getInstance().SetCW(1))
            {
                msg = "success!";
            }
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }
        private void btnSetCW_Click(object sender, EventArgs e)
        {
            string msg = "failure!";
            if (UHFAPI.getInstance().SetCW(0))
            {
                msg = "success!";
            }
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }
        #endregion

        #region 天线
        private void btnGetANT_Click(object sender, EventArgs e)
        {
            string msg = Common.isEnglish?"failure!":"获取天线失败!";
            byte[] ant = new byte[2];
            if (UHFAPI.getInstance().GetANT(ant))
            {
                foreach (Control control in this.groupBox10.Controls)
                {
                    if (control is CheckBox) {
                        CheckBox checkBox = (CheckBox)control;
                        checkBox.Checked = false;
                    }
                }
               // ant[0] = 00;
               // ant[1] = 03;

             //   MessageBox.Show("ant[0]=" + DataConvert.ByteArrayToHexString(new byte[] { ant[0] }) + "ant[1]="+DataConvert.ByteArrayToHexString(new byte[] { ant[1] }));

                string t1 = System.Convert.ToString(ant[0], 2);
                string t2  = System.Convert.ToString(ant[1], 2);

                string temp1 = "00000000".Substring(0, 8 - t1.Length) + t1;
                string temp2 = "00000000".Substring(0, 8 - t2.Length) + t2;

                if (temp2.Substring(0, 1) == "1") cmbAnt8.Checked = true;
                if (temp2.Substring(1, 1) == "1") cmbAnt7.Checked = true;
                if (temp2.Substring(2, 1) == "1") cmbAnt6.Checked = true;
                if (temp2.Substring(3, 1) == "1") cmbAnt5.Checked = true;
                if (temp2.Substring(4, 1) == "1") cmbAnt4.Checked = true;
                if (temp2.Substring(5, 1) == "1") cmbAnt3.Checked = true;
                if (temp2.Substring(6, 1) == "1") cmbAnt2.Checked = true;
                if (temp2.Substring(7, 1) == "1") cmbAnt1.Checked = true;

                if (temp1.Substring(0, 1) == "1") cmbAnt16.Checked = true;
                if (temp1.Substring(1, 1) == "1") cmbAnt15.Checked = true;
                if (temp1.Substring(2, 1) == "1") cmbAnt14.Checked = true;
                if (temp1.Substring(3, 1) == "1") cmbAnt13.Checked = true;
                if (temp1.Substring(4, 1) == "1") cmbAnt12.Checked = true;
                if (temp1.Substring(5, 1) == "1") cmbAnt11.Checked = true;
                if (temp1.Substring(6, 1) == "1") cmbAnt10.Checked = true;
                if (temp1.Substring(7, 1) == "1") cmbAnt9.Checked = true;

                msg = Common.isEnglish ? "success" : "获取天线成功!";
              //  msg = Common.isEnglish?"success":"获取天线成功!("+ DataConvert.ByteArrayToHexString(ant)+")";
            }
             
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }
        private void btnSetAnt_Click(object sender, EventArgs e)
        {
            string msg = Common.isEnglish?"failure":"设置天线失败!";
            StringBuilder sb1 = new StringBuilder();
            if (cmbAnt8.Checked) sb1.Append("1"); else sb1.Append("0");
            if (cmbAnt7.Checked) sb1.Append("1"); else sb1.Append("0");
            if (cmbAnt6.Checked) sb1.Append("1"); else sb1.Append("0");
            if (cmbAnt5.Checked) sb1.Append("1"); else sb1.Append("0");
            if (cmbAnt4.Checked) sb1.Append("1"); else sb1.Append("0");
            if (cmbAnt3.Checked) sb1.Append("1"); else sb1.Append("0");
            if (cmbAnt2.Checked) sb1.Append("1"); else sb1.Append("0");
            if (cmbAnt1.Checked) sb1.Append("1"); else sb1.Append("0");

            StringBuilder sb2 = new StringBuilder();
            if (cmbAnt16.Checked) sb2.Append("1"); else sb2.Append("0");
            if (cmbAnt15.Checked) sb2.Append("1"); else sb2.Append("0");
            if (cmbAnt14.Checked) sb2.Append("1"); else sb2.Append("0");
            if (cmbAnt13.Checked) sb2.Append("1"); else sb2.Append("0");
            if (cmbAnt12.Checked) sb2.Append("1"); else sb2.Append("0");
            if (cmbAnt11.Checked) sb2.Append("1"); else sb2.Append("0");
            if (cmbAnt10.Checked) sb2.Append("1"); else sb2.Append("0");
            if (cmbAnt9.Checked) sb2.Append("1"); else sb2.Append("0");

            byte[] ant = new[]{
                   Convert.ToByte(sb2.ToString(),2),
                   Convert.ToByte(sb1.ToString(),2)
            };
            
            byte flag = cbAntSet.Checked ? (byte)1 : (byte)0;
            if (UHFAPI.getInstance().SetANT(flag, ant))
            {
                msg = Common.isEnglish ? "success" : "设置天线成功!"; ;
               // msg = Common.isEnglish ? "success" : "设置天线成功!(" + DataConvert.ByteArrayToHexString(ant) + ")"; ;
            }
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);

        }


        private void btnGetANTWorkTime_Click(object sender, EventArgs e)
        {
            string msg = "failure";
            int ant = cmbAntWorkTime.SelectedIndex + 1;
            int time = 0;
            if (UHFAPI.getInstance().GetANTWorkTime((byte)ant, ref time))
            {
                txtAntWorkTime.Text = time.ToString();
                msg = "success";
            }
            
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }

        private void btnSetANTWorkTime_Click(object sender, EventArgs e)
        {
            string msg = "failure";
            int ant = cmbAntWorkTime.SelectedIndex+1;
            int time = int.Parse(txtAntWorkTime.Text);
            int flag = cbAntWorkTime.Checked ? 1 : 0;
            if (UHFAPI.getInstance().SetANTWorkTime((byte)ant, (byte)flag, time))
            {
                msg = "success";
            }
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }
        private void txtWorkTime_TextChanged(object sender, EventArgs e)
        {
            try
            {
                txtAntWorkTime.Text = txtAntWorkTime.Text.Trim();
                string workTime = txtAntWorkTime.Text;
                if (!StringUtils.IsNumber(workTime))
                {
                    txtAntWorkTime.Text = "";
                    return;
                }
                int time = int.Parse(workTime);
                if (time > 65535) {
                    txtAntWorkTime.Text = "65535";
                }
            }
            catch (Exception ex)
            {
                txtAntWorkTime.Text = "";
            }
        }
        private void txtWorkTime_LostFocus(object sender, EventArgs e)
        {
            try
            {
                txtAntWorkTime.Text = txtAntWorkTime.Text.Trim();
                string workTime = txtAntWorkTime.Text;
                if (!StringUtils.IsNumber(workTime))
                {
                    txtAntWorkTime.Text = "";
                    return;
                }
                int time = int.Parse(workTime);
                if (time <10)
                {
                    txtAntWorkTime.Text = "10";
                }
            }
            catch (Exception ex)
            {
                txtAntWorkTime.Text = "";
            }
        }
        
        
        #endregion

        #region 区域
        private void btnRegionGet_Click(object sender, EventArgs e)
        {
            //0x01(China1),0x02(China2),0x04(Europe),0x08(USA),0x16(Korea),0x32(Japan)
            string msg = Common.isEnglish?"Get the region failure!":"获取区域失败!";
            byte region=0;
            if (UHFAPI.getInstance().GetRegion(ref region))
            {
                switch (region) { 
                    case 0x01:
                        cmbRegion.SelectedIndex = 0;
                        break;
                    case 0x02:
                        cmbRegion.SelectedIndex = 1;
                        break;
                    case 0x04:
                        cmbRegion.SelectedIndex = 2;
                        break;
                    case 0x08:
                        cmbRegion.SelectedIndex = 3;
                        break;
                    case 0x16:
                        cmbRegion.SelectedIndex = 4;
                        break;
                    case 0x32:
                        cmbRegion.SelectedIndex = 5;
                        break;
                }
                msg=Common.isEnglish?"Get the region success":"获取区域成功!";
            }
            
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }

        private void btnRegionSet_Click(object sender, EventArgs e)
        {
            //0x01(China1),0x02(China2),0x04(Europe),0x08(USA),0x16(Korea),0x32(Japan)
            int flag = cbRegionSave.Checked ? 1 : 0;
            int region = -1;
            switch (cmbRegion.SelectedIndex)
            {
                case 0:
                    region = 0x01;
                    break;
                case 1:
                    region = 0x02;
                    break;
                case 2:
                    region = 0x04;
                    break;
                case 3:
                    region = 0x08;
                    break;
                case 4:
                    region = 0x16;
                    break;
                case 5:
                    region = 0x32;
                    break;
            }
            string msg = Common.isEnglish ? "Set the region failure!" : "设置区域失败!";
            if (region >= 0)
            {
                if (UHFAPI.getInstance().SetRegion((byte)flag, (byte)region))
                {
                    msg=Common.isEnglish? "Set the region success":"设置区域成功!";
                }
                 
            }
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }
        #endregion
        #region 温度保护
        private void GetTemperatureProtect_Click(object sender, EventArgs e)
        {
            byte flag = 0;
            string msg = Common.isEnglish ? "failure!" : "失败!";
            if (UHFAPI.getInstance().GetTemperatureProtect(ref flag))
            {
                if (flag == 1)
                {
                    rbEnable.Checked = true;
                    rbDisable.Checked = false;
                      msg = Common.isEnglish ? "success!" : "成功!";
                }
                else if (flag ==0)
                {
                    rbEnable.Checked = false;
                    rbDisable.Checked = true;
                      msg = Common.isEnglish ? "success!" : "成功!";
                }

            }
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }
        private void btnSetTemperatureProtect_Click(object sender, EventArgs e)
        {
            string msg = Common.isEnglish ? "failure!" : "失败!";
            int flag = 0;
            if (rbDisable.Checked)
            {
                flag = 0;
            }
            else if (rbEnable.Checked)
            {
                flag = 1;
            }
            if (UHFAPI.getInstance().SetTemperatureProtect((byte)flag))
            {
                msg = Common.isEnglish ? "success!" : "成功!";
            }
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }
        #endregion

        #region 链路组合
        private void btnRFLinkGet_Click(object sender, EventArgs e)
        {
            string msg = "failure";
            byte mode = 0;
            if (UHFAPI.getInstance().GetRFLink(ref mode))
            {
                cmbRFLink.SelectedIndex = mode;
                msg = "success";
            }
           
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }
        private void btnRFLinkSet_Click(object sender, EventArgs e)
        {
            string msg = "failure";
            int flag = cbRFLink.Checked ? 1 : 0;
            if (cmbRFLink.SelectedIndex >= 0)
            {
                if (UHFAPI.getInstance().SetRFLink((byte)flag, (byte)cmbRFLink.SelectedIndex)) {
                    msg = "success";
                }
            }
          
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }

        #endregion

        #region FastID
        private void btnFastIDGet_Click(object sender, EventArgs e)
        {
            byte flag = 0;
            string msg = "failure";
            if (UHFAPI.getInstance().GetFastID(ref flag))
            {
                if (flag == 0)
                {
                    rbFastIDEnable.Checked = false;
                    rbFastIDDisable.Checked = true;
                    msg = "success";
                }
                else if (flag == 1)
                {
                    rbFastIDEnable.Checked = true;
                    rbFastIDDisable.Checked = false;
                    msg = "success";
                }
            }
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }
        private void btnFastIDSet_Click(object sender, EventArgs e)
        {
            int flag = -1;
            string msg = "failure";
            if (rbFastIDEnable.Checked)
            {
                flag = 1;
            }
            else if (rbFastIDDisable.Checked)
            {
                flag = 0;
            }

            if (flag >= 0)
            {
                if (UHFAPI.getInstance().SetFastID((byte)flag))
                {
                    msg = "success";

                    if (flag == 1) {
                        if (UHFAPI.getInstance().SetTagfocus(0))
                        {
                            rbTagfocusDisable.Checked = true;
                        }
                        if (UHFAPI.getInstance().SetEPCTIDMode(0, 0))
                        {
                            rbEPCDisable.Checked = true;
                        }
                    }

                }
               
            }
            
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }
        #endregion

        #region Tagfocus
        private void btnrbTagfocusGet_Click(object sender, EventArgs e)
        {
            string msg = "failure";
            byte flag = 0;
            if (UHFAPI.getInstance().GetTagfocus(ref flag))
            {
                if (flag == 0)
                {
                    rbTagfocusEnable.Checked = false;
                    rbTagfocusDisable.Checked = true;
                    msg = "success";
                }
                else if (flag == 1)
                {
                    rbTagfocusEnable.Checked = true;
                    rbTagfocusDisable.Checked = false;
                    msg = "success";
                }
            }
            
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }
        private void btnrbTagfocusSet_Click(object sender, EventArgs e)
        {
            int flag = -1;
            string msg = "failure";
            if (rbTagfocusEnable.Checked)
            {
                flag = 1;
            }
            else if (rbTagfocusDisable.Checked)
            {
                flag = 0;
            }

            if (flag >= 0)
            {
                if (UHFAPI.getInstance().SetTagfocus((byte)flag))
                {
                    msg = "success";
                    if (flag == 1)
                    {

                        if (UHFAPI.getInstance().SetFastID(0))
                        {
                            rbFastIDDisable.Checked = true;
                        }
                 
                        if (UHFAPI.getInstance().SetEPCTIDMode(0, 0))
                        {
                            rbEPCDisable.Checked = true;
                        }
                    }
                }
                
            }
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);

        }
        #endregion
        #region 设置软复位
        private void btnReset_Click(object sender, EventArgs e)
        {
            string msg = Common.isEnglish ? "failure" : "设置软复位失败!";
            if (UHFAPI.getInstance().SetSoftReset())
            {
                msg = Common.isEnglish ? "success" : "设置软复位成功!";
            }
             
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }
        #endregion
        #region DualSingel
        private void btnDualSingelGet_Click(object sender, EventArgs e)
        {
            byte flag = 0;
            string msg = "failure";
            if (UHFAPI.getInstance().GetDualSingelMode(ref flag))
            {
                if (flag == 0)
                {
                    rbDual.Checked = true;
                    rbSingel.Checked = false;
                    msg = "success";
                }
                else if (flag == 1)
                {
                    rbDual.Checked = false;
                    rbSingel.Checked = true ;
                    msg = "success";
                }
            }
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }
        private void btnDualSingelSet_Click(object sender, EventArgs e)
        {
            int flag = -1;

            if (rbDual.Checked)
            {
                flag = 0;
            }
            else if (rbSingel.Checked)
            {
                flag =1 ;
            }
            string msg = "failure";
            if (flag >= 0)
            {
                int save = cbDualSingelSave.Checked ? 1 : 0;
                if (UHFAPI.getInstance().SetDualSingelMode((byte)save, (byte)flag))
                {
                    msg = "success";
                }
            }
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }
        #endregion

        #region EPC And Tid
        private void EPCGet_Click(object sender, EventArgs e)
        {
            string msg = Common.isEnglish?"failure":"获取失败!";
            byte mode=0;
            if (UHFAPI.getInstance().GetEPCTIDMode(ref mode))
            {
                if (mode == 0)
                {
                    rbEPCDisable.Checked = true;
                    rbEPCEnable.Checked = false;
                    msg = Common.isEnglish ? "success" : "获取成功!";
                }
                else if (mode == 1)
                {
                    rbEPCDisable.Checked = false;
                    rbEPCEnable.Checked = true;
                    msg = Common.isEnglish ? "success" : "获取成功!";
                }
            }
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }

        private void EPCSet_Click(object sender, EventArgs e)
        {
            string msg = Common.isEnglish ? "failure" : "设置失败!";
            int mode = -1;
            if (rbEPCDisable.Checked)
            {
                mode = 0;
            }
            else if (rbEPCEnable.Checked)
            {
                mode = 1;
            }
            if (mode >= 0)
            {
                int flag = cbEPCAndTID.Checked ? 1 : 0;
                if (UHFAPI.getInstance().SetEPCTIDMode((byte)flag,(byte)mode))
                {
                    msg = Common.isEnglish ? "success" : "设置成功!";
                    if (mode == 1)
                    {
                        if (UHFAPI.getInstance().SetFastID(0))
                        {
                            rbFastIDDisable.Checked = true;
                        }
                        if (UHFAPI.getInstance().SetTagfocus(0))
                        {
                            rbTagfocusDisable.Checked = true;
                        }
                     
                    }
                }
            }
            frmWaitingBox f = new frmWaitingBox((obj, args) =>
            {
                System.Threading.Thread.Sleep(500);
            }, msg);
            f.ShowDialog(this);
        }
        #endregion

        private void panel1_Paint(object sender, PaintEventArgs e)
        {

        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            string data = textBox1.Text.Trim().Replace(" ", "");
            if (data.Length > 0) {

                
                int index=textBox1.SelectionStart-1;
                if (index >= 0)
                {
                    string charData = data.Substring(index, 1);
                    if (charData != "0" && charData != "1" && charData != "2" 
                        && charData != "3" && charData != "4" && charData != "5" && charData != "6" && charData != "7"
                        && charData != "8" && charData != "9" && charData != ".")
                    {
                        textBox1.Text = textBox1.Text.Remove(index, 1);
                        textBox1.SelectionStart = textBox1.Text.Length;
                    }
                }
            }
   
        }



        private void MainForm_eventSwitchUI()
        {
            if (Common.isEnglish)
            {
                label2.Text = "";
                groupBox6.Text = "Power";
                label24.Text = "Output Power:";
                cbSave.Text = "Save";
             

                groupBox11.Text = "Region";
                label1.Text = "Region:";           
                cbRegionSave.Text = "Save";

                label5.Text = "RFLink:";
                groupBox3.Text = "RFLink";
                cbRFLink.Text = "cbSave";

                groupBox7.Text = "Rrequency";
                label28.Text = "Rrequency:";

                btnReset.Text = "Reset";

                groupBox10.Text = "ANT";
                groupBox8.Text = "TemperatureProtect";
                label24.Location = new Point(8, 34);
                label1.Location = new Point(51, 39);
                label5.Location = new Point(51, 33);
                label28.Location = new Point(27, 42);

                rbFastIDEnable.Text = rbTagfocusEnable.Text = rbEnable.Text = rbEPCEnable.Text = "Enable";
                rbFastIDDisable.Text = rbTagfocusDisable.Text = rbDisable.Text = rbEPCDisable.Text = "Disable";
            }
            else
            {
                label2.Text = "设置Gen2之前先获取";
                groupBox6.Text = "功率";
                label24.Text = "输出功率:";
                cbSave.Text = "保存";


                groupBox11.Text = "区域";
                label1.Text = "区域:";
                cbRegionSave.Text = "保存";

                label5.Text = "链路组合:";
                groupBox3.Text = "链路";
                cbRFLink.Text = "保存";

                groupBox7.Text = "跳频";
                label28.Text = "频点:";

                btnReset.Text = "还原出厂设置";

                groupBox10.Text = "天线";
                groupBox8.Text = "温度保护";

                label24.Location = new Point(30, 34);
                label1.Location = new Point(63, 39);
                label5.Location = new Point(40, 33);
                label28.Location = new Point(55, 42);

                rbFastIDEnable.Text = rbTagfocusEnable.Text = rbEnable.Text = rbEPCEnable.Text = "启用";
                rbFastIDDisable.Text = rbTagfocusDisable.Text = rbDisable.Text = rbEPCDisable.Text = "禁用";

            }

        }



























    }
}
